<?php

namespace App\Enums;

use App\Filament\Support\CheerfulNotification;
use App\Traits\Enum\WithComment;
use App\Traits\Enum\WithValue;
use Filament\Support\Contracts\HasColor;
use Filament\Support\Contracts\HasLabel;

enum ApprovalStatus: int implements HasColor, HasLabel
{
    use WithComment, WithValue;

    case PENDING = 1;
    case ACCEPTED = 2;
    case REJECTED = 3;

    public function getLabel(): ?string
    {
        return match ($this) {
            self::PENDING => CheerfulNotification::getByKey('enum.approval_status.pending'),
            self::ACCEPTED => CheerfulNotification::getByKey('enum.approval_status.accepted'),
            self::REJECTED => CheerfulNotification::getByKey('enum.approval_status.rejected'),
        };
    }

    public function getColor(): string|array|null
    {
        return match ($this) {
            self::PENDING => 'warning',
            self::ACCEPTED => 'success',
            self::REJECTED => 'danger',
        };
    }

    public static function options(): array
    {
        return collect(self::cases())
            ->mapWithKeys(fn ($case) => [$case->value => $case->getLabel()])
            ->toArray();
    }
}
